'use strict';

var _assert = require('assert');

var _assert2 = _interopRequireDefault(_assert);

var _index = require('../index');

var _index2 = _interopRequireDefault(_index);

var _helper = require('./helper');

var _helper2 = _interopRequireDefault(_helper);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var ERROR_ID = 'form.errors.absence';

function test(value) {
  return (0, _helper2.default)((0, _index.absence)()(value));
}

describe('Validator: absence', function () {
  it('should be invalid when `value` is not empty', function () {
    _assert2.default.equal(ERROR_ID, test(1));
    _assert2.default.equal(ERROR_ID, test('str'));
    _assert2.default.equal(ERROR_ID, test(' abc '));
    _assert2.default.equal(ERROR_ID, test(new File()));
    _assert2.default.equal(ERROR_ID, test(new FileList({ length: 1 })));
    _assert2.default.equal(ERROR_ID, test(new FileList([{}])));
  });
  it('should be valid when `value` is empty', function () {
    _assert2.default.ok(!test());
    _assert2.default.ok(!test(''));
    _assert2.default.ok(!test('   '));
    _assert2.default.ok(!test(' \n \t '));
    _assert2.default.ok(!test(new FileList()));
    _assert2.default.ok(!test(new FileList([])));
    _assert2.default.ok(!test(new FileList({ length: 0 })));
  });
  it('should use formatMessage', function () {
    var defaultValue = _index2.default.formatMessage;

    _index2.default.formatMessage = function (msg) {
      return Object.assign({}, msg, { id: msg.id + '2' });
    };
    _assert2.default.equal(ERROR_ID + '2', test(1));

    _index2.default.formatMessage = defaultValue;
  });
});