# User guide

## Introduction

-   [FAQ](user-guide/faq.md): Frequently asked questions about using and configuring stylelint.
-   [About rules](user-guide/about-rules.md): An explanation of rule names and how rules work together.
-   [Semantic versioning policy](user-guide/semantic-versioning-policy.md): An explanation of our policy on semantic versioning.

## Configuration

-   [Configuration](user-guide/configuration.md): How to configure stylelint.
    -   [Rules](user-guide/rules.md): A list of stylelint's rules.
    -   [Plugins](user-guide/plugins.md): A list of community plugins.
    -   [Processors](user-guide/processors.md): A list of community processors.
-   [Example config](user-guide/example-config.md): An example config that you can use as a blueprint for your own.
-   [CSS processors](user-guide/css-processors.md): How to use the linter with a CSS processor, like SCSS or PostCSS plugins.

## Usage

-   [The CLI](user-guide/cli.md): Examples and exit codes for using the CLI.
-   [The Node API](user-guide/node-api.md): Options and examples for using the Node API.
-   [The PostCSS plugin](user-guide/postcss-plugin.md): Options and examples for using the PostCSS plugin.
-   [Complementary tools](user-guide/complementary-tools.md): List of community editor plugins, build tool plugins and other tools.

## Further reading

-   [Articles](user-guide/articles.md): A collection of articles and tutorials about stylelint.
